Package org.apache.commons.collections4.bidimap

# Class UnmodifiableSortedBidiMap<K,V>

java.lang.Object
org.apache.commons.collections4.map.AbstractIterableMap<K,V>
org.apache.commons.collections4.map.AbstractMapDecorator<K,V>
org.apache.commons.collections4.bidimap.AbstractBidiMapDecorator<K,V>
org.apache.commons.collections4.bidimap.AbstractOrderedBidiMapDecorator<K,V>
org.apache.commons.collections4.bidimap.AbstractSortedBidiMapDecorator<K,V>
org.apache.commons.collections4.bidimap.UnmodifiableSortedBidiMap<K,V>

Type Parameters:
  `K` - the type of the keys in this map
  `V` - the type of the values in this map

All Implemented Interfaces:
  `Map<K,V>`, `SortedMap<K,V>`, `BidiMap<K,V>`, `Get<K,V>`, `IterableGet<K,V>`, `IterableMap<K,V>`, `OrderedBidiMap<K,V>`, `OrderedMap<K,V>`, `Put<K,V>`, `SortedBidiMap<K,V>`, `Unmodifiable`

public final class UnmodifiableSortedBidiMap<K,V> extends AbstractSortedBidiMapDecorator<K,V> implements Unmodifiable
Decorates another `SortedBidiMap` to ensure it can't be altered.

Attempts to modify it will result in an `UnsupportedOperationException`.

Since:
  3.0

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface java.util.Map

  `Map.Entry<K extends Object,V extends Object>`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `clear()`
  `Set<Map.Entry<K,V>>`
  `entrySet()`
  `SortedMap<K,V>`
  `headMap(K toKey)`
  `SortedBidiMap<V,K>`
  `inverseBidiMap()`
  Gets a view of this map where the keys and values are reversed.
  `Set<K>`
  `keySet()`
  `OrderedMapIterator<K,V>`
  `mapIterator()`
  Obtains a `MapIterator` over the map.
  `V`
  `put(K key, V value)`
  Note that the return type is Object, rather than V as in the Map interface.
  `void`
  `putAll(Map<? extends K,? extends V> mapToCopy)`
  `V`
  `remove(Object key)`
  `K`
  `removeValue(Object value)`
  Removes the key-value pair that is currently mapped to the specified value (optional operation).
  `SortedMap<K,V>`
  `subMap(K fromKey, K toKey)`
  `SortedMap<K,V>`
  `tailMap(K fromKey)`
  `static <K, V> SortedBidiMap<K,V>`
  `unmodifiableSortedBidiMap(SortedBidiMap<K,? extends V> map)`
  Factory method to create an unmodifiable map.
  `Set<V>`
  `values()`
  Returns a `Set` view of the values contained in this map.

  ### Methods inherited from class org.apache.commons.collections4.bidimap.AbstractSortedBidiMapDecorator

  `comparator, decorated, valueComparator`

  ### Methods inherited from class org.apache.commons.collections4.bidimap.AbstractOrderedBidiMapDecorator

  `firstKey, lastKey, nextKey, previousKey`

  ### Methods inherited from class org.apache.commons.collections4.bidimap.AbstractBidiMapDecorator

  `getKey`

  ### Methods inherited from class org.apache.commons.collections4.map.AbstractMapDecorator

  `containsKey, containsValue, equals, get, hashCode, isEmpty, size, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.apache.commons.collections4.BidiMap

  `getKey`

  ### Methods inherited from interface org.apache.commons.collections4.Get

  `containsKey, containsValue, get, isEmpty, size`

  ### Methods inherited from interface java.util.Map

  `compute, computeIfAbsent, computeIfPresent, containsKey, containsValue, equals, forEach, get, getOrDefault, hashCode, isEmpty, merge, putIfAbsent, remove, replace, replace, replaceAll, size`

  ### Methods inherited from interface org.apache.commons.collections4.OrderedMap

  `firstKey, lastKey, nextKey, previousKey`

  ### Methods inherited from interface java.util.SortedMap

  `firstKey, lastKey`

- ## Method Details

  - ### unmodifiableSortedBidiMap

    public static <K, V> SortedBidiMap<K,V> unmodifiableSortedBidiMap(SortedBidiMap<K,? extends V> map)
    Factory method to create an unmodifiable map.

    If the map passed in is already unmodifiable, it is returned.

    Type Parameters:
      `K` - the key type
      `V` - the value type
    Parameters:
      `map` - the map to decorate, must not be null
    Returns:
      an unmodifiable SortedBidiMap
    Throws:
      `NullPointerException` - if map is null
    Since:
      4.0

  - ### clear

    public void clear()
    Specified by:
      `clear` in interface `Map<K,V>`
    Specified by:
      `clear` in interface `Put<K,V>`
    Overrides:
      `clear` in class `AbstractMapDecorator<K,V>`
    See Also:
      - `Map.clear()`

  - ### entrySet

    public Set<Map.Entry<K,V>> entrySet()
    Specified by:
      `entrySet` in interface `Get<K,V>`
    Specified by:
      `entrySet` in interface `Map<K,V>`
    Specified by:
      `entrySet` in interface `SortedMap<K,V>`
    Overrides:
      `entrySet` in class `AbstractMapDecorator<K,V>`
    Returns:
      a set view of the mappings contained in this map
    See Also:
      - `Map.entrySet()`

  - ### headMap

    public SortedMap<K,V> headMap(K toKey)
    Specified by:
      `headMap` in interface `SortedMap<K,V>`
    Overrides:
      `headMap` in class `AbstractSortedBidiMapDecorator<K,V>`

  - ### inverseBidiMap

    public SortedBidiMap<V,K> inverseBidiMap()
    Description copied from interface: `BidiMap`
    Gets a view of this map where the keys and values are reversed.

    Changes to one map will be visible in the other and vice versa. This enables both directions of the map to be accessed as a `Map`.

    Implementations should seek to avoid creating a new object every time this method is called. See `AbstractMap.values()` etc. Calling this method on the inverse map should return the original.

    Specified by:
      `inverseBidiMap` in interface `BidiMap<K,V>`
    Specified by:
      `inverseBidiMap` in interface `OrderedBidiMap<K,V>`
    Specified by:
      `inverseBidiMap` in interface `SortedBidiMap<K,V>`
    Overrides:
      `inverseBidiMap` in class `AbstractSortedBidiMapDecorator<K,V>`
    Returns:
      an inverted bidirectional map

  - ### keySet

    public Set<K> keySet()
    Specified by:
      `keySet` in interface `Get<K,V>`
    Specified by:
      `keySet` in interface `Map<K,V>`
    Specified by:
      `keySet` in interface `SortedMap<K,V>`
    Overrides:
      `keySet` in class `AbstractMapDecorator<K,V>`
    Returns:
      a set view of the keys contained in this map
    See Also:
      - `Map.keySet()`

  - ### mapIterator

    public OrderedMapIterator<K,V> mapIterator()
    Description copied from class: `AbstractIterableMap`
    Obtains a `MapIterator` over the map.

    A map iterator is an efficient way of iterating over maps. There is no need to access the entry set or use Map Entry objects.

         IterableMap<String,Integer> map = new HashedMap<String,Integer>();
         MapIterator<String,Integer> it = map.mapIterator();
         while (it.hasNext()) {
           String key = it.next();
           Integer value = it.getValue();
           it.setValue(value + 1);
         }

    Specified by:
      `mapIterator` in interface `IterableGet<K,V>`
    Specified by:
      `mapIterator` in interface `OrderedMap<K,V>`
    Overrides:
      `mapIterator` in class `AbstractOrderedBidiMapDecorator<K,V>`
    Returns:
      a map iterator

  - ### put

    public V put(K key, V value)
    Description copied from interface: `Put`
    Note that the return type is Object, rather than V as in the Map interface. See the class Javadoc for further info.
    Specified by:
      `put` in interface `BidiMap<K,V>`
    Specified by:
      `put` in interface `Map<K,V>`
    Specified by:
      `put` in interface `Put<K,V>`
    Overrides:
      `put` in class `AbstractMapDecorator<K,V>`
    Parameters:
      `key` - key with which the specified value is to be associated
      `value` - value to be associated with the specified key
    Returns:
      the previous value associated with `key`, or `null` if there was no mapping for `key`. (A `null` return can also indicate that the map previously associated `null` with `key`, if the implementation supports `null` values.)
    See Also:
      - `Map.put(Object, Object)`

  - ### putAll

    public void putAll(Map<? extends K,? extends V> mapToCopy)
    Specified by:
      `putAll` in interface `Map<K,V>`
    Specified by:
      `putAll` in interface `Put<K,V>`
    Overrides:
      `putAll` in class `AbstractMapDecorator<K,V>`
    Parameters:
      `mapToCopy` - mappings to be stored in this map
    See Also:
      - `Map.putAll(Map)`

  - ### remove

    public V remove(Object key)
    Specified by:
      `remove` in interface `Get<K,V>`
    Specified by:
      `remove` in interface `Map<K,V>`
    Overrides:
      `remove` in class `AbstractMapDecorator<K,V>`
    Parameters:
      `key` - key whose mapping is to be removed from the map
    Returns:
      the previous value associated with `key`, or `null` if there was no mapping for `key`.
    See Also:
      - `Map.remove(Object)`

  - ### removeValue

    public K removeValue(Object value)
    Description copied from interface: `BidiMap`
    Removes the key-value pair that is currently mapped to the specified value (optional operation).

    If the value is not contained in the map, `null` is returned.

    Implementations should seek to make this method perform equally as well as `remove(Object)`.

    Specified by:
      `removeValue` in interface `BidiMap<K,V>`
    Overrides:
      `removeValue` in class `AbstractBidiMapDecorator<K,V>`
    Parameters:
      `value` - the value to find the key-value pair for
    Returns:
      the key that was removed, `null` if nothing removed

  - ### subMap

    public SortedMap<K,V> subMap(K fromKey, K toKey)
    Specified by:
      `subMap` in interface `SortedMap<K,V>`
    Overrides:
      `subMap` in class `AbstractSortedBidiMapDecorator<K,V>`

  - ### tailMap

    public SortedMap<K,V> tailMap(K fromKey)
    Specified by:
      `tailMap` in interface `SortedMap<K,V>`
    Overrides:
      `tailMap` in class `AbstractSortedBidiMapDecorator<K,V>`

  - ### values

    public Set<V> values()
    Description copied from interface: `BidiMap`
    Returns a `Set` view of the values contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress (except through the iterator's own `remove` operation), the results of the iteration are undefined. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the `add` or `addAll` operations.
    Specified by:
      `values` in interface `BidiMap<K,V>`
    Specified by:
      `values` in interface `Get<K,V>`
    Specified by:
      `values` in interface `Map<K,V>`
    Specified by:
      `values` in interface `SortedMap<K,V>`
    Overrides:
      `values` in class `AbstractBidiMapDecorator<K,V>`
    Returns:
      a collection view of the values contained in this map
    See Also:
      - `Map.values()`